/**************************************************************
 * Original:
 * Patrick Powell Tue Apr 11 09:48:21 PDT 1995
 * A bombproof version of doprnt (dopr) included.
 * Sigh.  This sort of thing is always nasty do deal with.  Note that
 * the version here does not include floating point...
 *
 * plp_snprintf() is used instead of sprintf() as it does limit checks
 * for string length.  This covers a nasty loophole.
 *
 * The other functions are there to prevent NULL pointers from
 * causing nast effects.

      Added floating point support.
    
 **************************************************************/

static char _id[] = "$Id: snprintf.c,v 1.1 1995/08/19 20:36:09 papowell Exp $";
static void dopr();
static char *end;

#if defined(HAVE_CONFIG_H)
# include config.h
#endif
#include <stdio.h>
#include <ctype.h>
#include <string.h>

#define HAVE_STDARG_H 
/*typedef int size_t; */
/* varargs declarations: */

#if defined(HAVE_STDARG_H)
# include <stdarg.h>
# define HAVE_STDARGS    /* let's hope that works everywhere (mj) */
# define VA_LOCAL_DECL   va_list ap;
# define VA_START(f)     va_start(ap, f)
# define VA_SHIFT(v,t)  ;   /* no-op for ANSI */
# define VA_END          va_end(ap)
#else
# if defined(HAVE_VARARGS_H)
#  include <varargs.h>
#  undef HAVE_STDARGS
#  define VA_LOCAL_DECL   va_list ap;
#  define VA_START(f)     va_start(ap)      /* f is ignored! */
#  define VA_SHIFT(v,t) v = va_arg(ap,t)
#  define VA_END        va_end(ap)
# else
XX ** NO VARARGS ** XX
# endif
#endif

#ifdef HAVE_STDARGS
int plp_snprintf (char *str, size_t count, const char *fmt, ...);
int vplp_snprintf (char *str, size_t count, const char *fmt, va_list arg);
void setproctitle( char *fmt, ... );
#else
int plp_snprintf ();
int vplp_snprintf ();
void setproctitle();
#endif


void fmtflt( double xvalue, char *start, int len);
void fmtpnt( void *xvalue, char *start, int len);
void fmtint( int xvalue, char *start, int len);

int vplp_snprintf(str, count, fmt, args)
       char *str;
       size_t count;
       const char *fmt;
       va_list args;
{
       str[0] = 0;
       end = str+count-1;
       dopr( str, fmt, args );
       if( count>0 ){
               end[0] = 0;
       }
       return(strlen(str));
}

/* VARARGS3 */
#ifdef HAVE_STDARGS
int plp_snprintf (char *str,size_t count,const char *fmt,...)
#else
int plp_snprintf (va_alist) va_dcl
#endif
{
#ifndef HAVE_STDARGS
    char *str;
       size_t count;
    char *fmt;
#endif
    VA_LOCAL_DECL

    VA_START (fmt);
    VA_SHIFT (str, char *);
    VA_SHIFT (count, size_t );
    VA_SHIFT (fmt, char *);
    (void) vplp_snprintf ( str, count, fmt, ap);
    VA_END;
       return( strlen( str ) );
}

/*
 * dopr(): poor man's version of doprintf
 */

static void fmtstr(  char *value, int ljust, int len, int zpad , int max);
static void fmtnum(  long value, int base, int dosign,
       int ljust, int len, int zpad );
static void dostr( char * , int max);
static char *output;
static void dopr_outch( int c );

static void dopr( buffer, format, args )
       char *buffer;
       char *format;
       va_list args;
{
       int ch;
       long value;
       double xvalue;
       void *xpoint;
       int longflag = 0;
       char *strvalue;
	char *start;
       int ljust;
       int len;
       int zpad;
       int prec = -1;
       int indotlen = 0;
       int dotlen = 0;

       output = buffer;
       while( (ch = *format++) ){
               switch( ch ){
               case '%':
                       ljust = len = zpad = 0;
		       indotlen = 0;
		       dotlen = 0;
		       start = format-1;
               nextch: 
                       ch = *format++;
                       switch( ch ){
                       case 0:
                               dostr( "**end of format**" ,-1);
                               return;
                       case '-': ljust = 1; goto nextch;
                       case '0': /* set zero padding if len not set */
                               if (!indotlen) if(len==0) zpad = '0';
                       case '1': case '2': case '3':
                       case '4': case '5': case '6':
                       case '7': case '8': case '9':
			       if (indotlen) {
	                               dotlen = dotlen*10 + ch - '0';
			       } else {
	                               len = len*10 + ch - '0';
			       }
                               goto nextch;
                       case 'l': longflag = 1; goto nextch;
                       case 'u': case 'U':
                               /*fmtnum(value,base,dosign,ljust,len,zpad) */
                               if( longflag ){
                                       value = va_arg( args, long );
                               } else {
                                       value = va_arg( args, int );
                               }
                               fmtnum( value, 10,0, ljust, len, zpad ); break;
                       case 'o': case 'O':
                               /*fmtnum(value,base,dosign,ljust,len,zpad) */
                               if( longflag ){
                                       value = va_arg( args, long );
                               } else {
                                       value = va_arg( args, int );
                               }
                               fmtnum( value, 8,0, ljust, len, zpad ); break;
                       case 'x': case 'X':
                       case 'd': case 'D':
				value = va_arg(args,int);
				fmtint( value, start, format-start); 
				break;
                       case 'p': case 'P':
				xpoint = va_arg(args,void *);
				fmtpnt( xpoint, start, format-start); 
				break;
                       case 'f': case 'F':
                       case 'e': case 'E':
                       case 'g': case 'G':
				xvalue = va_arg(args,double);
				fmtflt( xvalue, start, format-start); 
				break;
/*                       case 'd': case 'D':
                               if( longflag ){
                                       value = va_arg( args, long );
                               } else {
                                       value = va_arg( args, int );
                               }
                               fmtnum( value, 10,1, ljust, len, zpad ); break;
                       case 'x':
                               if( longflag ){
                                       value = va_arg( args, long );
                               } else {
                                       value = va_arg( args, int );
                               }
                               fmtnum( value, 16,0, ljust, len, zpad ); break;
                       case 'X':
                               if( longflag ){
                                       value = va_arg( args, long );
                               } else {
                                       value = va_arg( args, int );
                               }
                               fmtnum( value,-16,0, ljust, len, zpad ); break;
*/
                       case 's':
                               strvalue = va_arg( args, char *);
			       if (strvalue==NULL) dostr("(NULL)",-1);
			       else fmtstr( strvalue,ljust,len,zpad,dotlen ); break;
		       case '.': 
				indotlen = 1;
		       case '+': 
                               goto nextch; /* Ignore */
                       case 'c':
                               ch = va_arg( args, int );
                               dopr_outch( ch ); break;
                       case '%': dopr_outch( ch ); continue;
                       default:
                               dostr(  "???????" ,-1);
                       }
                       longflag = 0;
                       break;
               default:
                       dopr_outch( ch );
                       break;
               }
       }
       *output = 0;
}

static void
fmtstr(  value, ljust, len, zpad , max)
       char *value;
       int ljust, len, zpad, max;
{
       int padlen, strlen;     /* amount to pad */

       if( value == 0 ){
               value = "<NULL>";
       }
       for( strlen = 0; value[strlen]; ++ strlen ); /* strlen */
       padlen = len - strlen;
       if( padlen < 0 ) padlen = 0;
       if( ljust ) padlen = -padlen;
       while( padlen > 0 ) {
               dopr_outch( ' ' );
               --padlen;
       }
       dostr( value ,max);
       while( padlen < 0 ) {
               dopr_outch( ' ' );
               ++padlen;
       }
}
void fmtflt( double xvalue, char *start, int len)
{
	char fmt[100];
	char *s;
	char bf[100];
	if (len<0) return;
	if (len>20) return;
	strncpy(fmt,start,len);
	fmt[len] = 0;
	if (strchr(fmt+1,'%')!=NULL) return;
	sprintf(bf,fmt,xvalue);

	for (s = bf; *s!=0; s++) {
		dopr_outch( *s );
	}
	
}
void fmtint( int xvalue, char *start, int len)
{
	char fmt[100];
	char *s;
	char bf[100];
	if (len<0) return;
	if (len>20) return;
	strncpy(fmt,start,len);
	fmt[len] = 0;
	if (strchr(fmt+1,'%')!=NULL) return;
	sprintf(bf,fmt,xvalue);

	for (s = bf; *s!=0; s++) {
		dopr_outch( *s );
	}
	
}
void fmtpnt( void *xvalue, char *start, int len)
{
	char fmt[100];
	char *s;
	char bf[100];
	if (len<0) return;
	if (len>20) return;
	strncpy(fmt,start,len);
	fmt[len] = 0;
	if (strchr(fmt+1,'%')!=NULL) return;
	sprintf(bf,fmt,xvalue);

	for (s = bf; *s!=0; s++) {
		dopr_outch( *s );
	}
	
}
static void
fmtnum(  value, base, dosign, ljust, len, zpad )
       long value;
       int base, dosign, ljust, len, zpad;
{
       int signvalue = 0;
       unsigned long uvalue;
       char convert[20];
       int place = 0;
       int padlen = 0; /* amount to pad */
       int caps = 0;

       /* DEBUGP(("value 0x%x, base %d, dosign %d, ljust %d, len %d, zpad %d\n",
               value, base, dosign, ljust, len, zpad )); */
       uvalue = value;
       if( dosign ){
               if( value < 0 ) {
                       signvalue = '-';
                       uvalue = -value; 
               }
       }
       if( base < 0 ){
               caps = 1;
               base = -base;
       }
       do{
               convert[place++] =
                       (caps? "0123456789ABCDEF":"0123456789abcdef")
                        [uvalue % (unsigned)base  ];
               uvalue = (uvalue / (unsigned)base );
       }while(uvalue);
       convert[place] = 0;
       padlen = len - place;
       if( padlen < 0 ) padlen = 0;
       if( ljust ) padlen = -padlen;
       /* DEBUGP(( "str '%s', place %d, sign %c, padlen %d\n",
               convert,place,signvalue,padlen)); */
       if( zpad && padlen > 0 ){
               if( signvalue ){
                       dopr_outch( signvalue );
                       --padlen;
                       signvalue = 0;
               }
               while( padlen > 0 ){
                       dopr_outch( zpad );
                       --padlen;
               }
       }
       while( padlen > 0 ) {
               dopr_outch( ' ' );
               --padlen;
       }
       if( signvalue ) dopr_outch( signvalue );
       while( place > 0 ) dopr_outch( convert[--place] );
       while( padlen < 0 ){
               dopr_outch( ' ' );
               ++padlen;
       }
}

static void dostr( str, max )
       char *str;
	int max;
{
	if (max<=0) max = 1000000;
       while(*str) {
	       if (max<=0) break;
	       max--;
	       dopr_outch(*str++);
       }
}

static void dopr_outch( c )
       int c;
{
/*       if( iscntrl(c) && c != '\n' && c != '\t' ){
               c = '@' + (c & 0x1F);
               if( end == 0 || output < end ){
                       *output++ = '^';
               }
       }
       */
       if( end == 0 || output < end ){
               *output++ = c;
       }
}
/*#define TESTING*/
#ifdef TESTING

main()
{
	char bf[200];
	int start;
	int i;

	plp_snprintf(bf,100,"%s %g %d %f %2.3f %.3f %+3.3g %5f\n","helo", 2.3, 4, 4.5, 2.333 , 222.33333, 222.3333, 232.234234234);
	printf("%s",bf);
	printf("%s %g %d %f %2.3f %.3f %+3.3g %5f\n","helo",2.3,4,4.5,2.333,222.33333,222.3333,232.234234234);

	plp_snprintf(bf,100,"%4.8s %.20s %04d\n","aaaaaaaaaaaaaaaaa","bbbbbbbbbbbbbbbbb",30);
	printf("%s",bf);
	printf("%4.8s %.20s %04d\n","aaaaaaaaaaaaaaaaa","bbbbbbbbbbbbbbbbb",30);

	plp_snprintf(bf,100,"%.5s\n","aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa");
	printf("%s",bf);
	printf("%.5s\n","aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa");

	strcpy(bf,"1234567890");
	plp_snprintf(bf,5,"%.20s\n","aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa");
	printf("%s\n",bf);
	strcpy(bf,"1234567890");
	_snprintf(bf,5,"%.20s\n","aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa");
	printf("%s\n",bf);

	start = time(NULL);
	for (i=0; i<30000; i++) {
		plp_snprintf(bf,100,"Long test string to see how fast it is %s %g %d %f %2.3f %.3f %+3.3g %5f\n","helo", 2.3, 4, 4.5, 2.333 , 222.33333, 222.3333, 232.234234234);
	}
	printf("elapsed %d\n",time(NULL) - start);

	return 1;
}
#endif